package dev.peerat.parser.java.builder;

import java.util.List;
import java.util.function.Function;

import dev.peerat.parser.Parser;
import dev.peerat.parser.java.JavaElement;
import dev.peerat.parser.java.JavaParser;
import dev.peerat.parser.java.operation.Operation;
import dev.peerat.parser.java.operation.Operation.OperationContainer;
import dev.peerat.parser.java.tree.JavaTreeType;
import dev.peerat.parser.java.visitor.JavaVisitor;
import dev.peerat.parser.visitor.Visitor;
import dev.peerat.parser.visitor.VisitorBag;

public class JavaOperationBuilder extends JavaBuilder<Operation>{

	private static Parser<JavaElement> PARSER = new JavaParser(JavaTreeType.OPERATION);
	
	private Operation operation;
	
	public JavaOperationBuilder(String operation) throws Exception{
		PARSER.parse(operation, new Container());
	}

	@Override
	public Operation build(){
		return this.operation;
	}

	class Container extends JavaElement implements OperationContainer{

		@Override
		public void addOperation(Operation operation){
			JavaOperationBuilder.this.operation = operation;
		}
		
		@Override
		public <E extends JavaElement> E find(Function<JavaElement, Boolean> finder) {
			return null;
		}

		@Override
		public <E extends JavaElement> void findAll(Function<JavaElement, Boolean> finder, List<E> list) {
			
		}

		@Override
		public VisitorBag visit(Visitor<JavaElement> visitor) {
			return null;
		}
		
	}
}
