package dev.peerat.parser.java.printer;

import java.lang.reflect.Modifier;

import dev.peerat.parser.java.Class;
import dev.peerat.parser.java.JavaElement;
import dev.peerat.parser.java.Variable;

public class JavaClassPrinter extends JavaPrinter<dev.peerat.parser.java.Class>{

	@Override
	public void print(Class element, Writer writer, String buffer, JavaPrintProvider provider) throws Exception {
		writer.write(buffer+Modifier.toString(element.getModifier())+" class ");
		writer.write(element.getName());
		if(element.getExtension() != null){
			writer.write(" extends ");
			writer.write(element.getExtension());
		}
		if(element.getImplementations() != null){
			writer.write(" implements ");
			writer.write(element.getImplementations());
		}
		writer.write("{\n");
		for(JavaElement content : element.getElements()){
			provider.getPrinter(content).print(content, writer, buffer+"\t", provider);
			if(content instanceof Variable) writer.write(";");
			writer.write("\n");
		}
		writer.write("}\n");
	}

}
