package dev.peerat.parser.java.value;

import java.util.List;
import java.util.function.Function;

import dev.peerat.parser.Token;
import dev.peerat.parser.java.JavaElement;
import dev.peerat.parser.visitor.Visitor;
import dev.peerat.parser.visitor.VisitorBag;

public class StaticValue extends Value{
	
	private Token token;
	
	public StaticValue(Token token){
		this.token = token;
	}
	
	public Token getToken(){
		return this.token;
	}

	@Override
	public <E extends JavaElement> E find(Function<JavaElement, Boolean> finder) {
		return null;
	}

	@Override
	public <E extends JavaElement> void findAll(Function<JavaElement, Boolean> finder, List<E> list) {
		
	}

	
	@Override
	public String toString(){
		return "StaticValue["+token.getValue()+"]";
	}

	@Override
	public VisitorBag visit(Visitor<JavaElement> visitor) {
		if(visitor.canVisit(getClass())) return visitor.visit(this);
		VisitorBag bag = new VisitorBag();
		return bag;
	}
}
